
var browserController = JSB.defineClass('browserController : UIViewController', {
  viewDidLoad: function() {
  self.homePageURL = 'https://m.inftab.com/'
  self.homeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/home.png`), 2)
  self.gobackImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goback.png`), 2)
  self.goforwardImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goforward.png`), 2)
  self.reloadImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/reload.png`), 2)
  self.stopImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/stop.png`), 2)
  self.screenImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/screen.png`), 2)
  // let NDdict= NSDictionary.dictionaryWithObjectsAndKeys("UserAgent",'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15')

    // let request = NSMutableURLRequest.requestWithURL(NSURL.URLWithString('https://useragent.buyaocha.com/'))
    // request.setAllHTTPHeaderFields(headers)
  //     NSUserDefaults.standardUserDefaults().registerDefaults({UserAgent:'Mozilla/5.0 (Linux; Android 4.2.1; M040 Build/JOP40D) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.59 Mobile Safari/537.36'});
  // NSUserDefaults.standardUserDefaults().removeObjectForKey("UserAgent")
  // NSUserDefaults.standardUserDefaults().registerDefaults({UserAgent:'Mozilla/5.0 (Linux; Android 4.2.1; M040 Build/JOP40D) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.59 Mobile Safari/537.36'});  
  // NSUserDefaults.standardUserDefaults().synchronize();
    // self.request = NSMutableURLRequest.requestWithURL(NSURL.URLWithString('https://useragent.buyaocha.com/'))
    // try {
    // request.setHTTPMethod("GET")
    // request.setValueForHTTPHeaderField('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"User-Agent")
    // } catch (error) {
    //   Application.sharedInstance().showHUD("error", self.view.window, 2);
    // }
    // NSUserDefaults.standardUserDefaults().registerDefaults({UserAgent:'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36'});
    // self.navigationItem.UserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36';
    self.custom = false;
    self.customMode = "None"
    self.dynamic = true;
    self.minimized = false;
    self.maximized = false
    self.miniMode = false;
    self.selectedText = '';
    self.engine = 'Bing'
    self.isLoading = false;
    self.toolbarOn = true
    self.lastFrame = self.view.frame;
    self.ishacked = false;
    self.isMainWindow = true
    self.title = "main"
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.opacity = 1.0
    self.frame = self.view.frame;

    // >>> DeepL view >>>
    self.webview = new UIWebView(self.view.bounds);
    // NSUserDefaults.standardUserDefaults().setObjectForKey('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"UserAgent")

    //  Application.sharedInstance().showHUD("error", self.view.window, 2);
    self.webview.url = self.homePageURL;
    self.webview.backgroundColor = UIColor.whiteColor();
    self.webview.scalesPageToFit = true;
    self.webview.autoresizingMask = (1 << 1 | 1 << 4);
    self.webview.delegate = self;
    // self.webview.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
    self.webview.scrollView.delegate = self;
    self.webview.layer.cornerRadius = 15;
    self.webview.layer.masksToBounds = true;
    // self.webview.loadRequest(
    //   request
    // );
    // self.mdxDictView = new UIWebView(self.view.bounds);
    // self.mdxDictView.backgroundColor = UIColor.whiteColor();
    // self.mdxDictView.scalesPageToFit = true;
    // self.mdxDictView.autoresizingMask = (1 << 1 | 1 << 4);
    // self.mdxDictView.delegate = self;
    // self.mdxDictView.scrollView.delegate = self;
    // self.mdxDictView.layer.cornerRadius = 10;
    // self.mdxDictView.layer.masksToBounds = true;
    // self.mdxDictView.loadFileURLAllowingReadAccessToURL(
    //   NSURL.fileURLWithPath(self.mainPath + '/test.html'),
    //   NSURL.fileURLWithPath(self.mainPath + '/')
    // );
    // self.view.addSubview(self.mdxDictView);

    self.webview.loadRequest(
      NSURLRequest.requestWithURL(NSURL.URLWithString(self.homePageURL))
    );
    // self.updateOffset();
    self.highlightColor = UIColor.blendedColor(
      UIColor.colorWithHexString("#2c4d81").colorWithAlphaComponent(0.8),
      Application.sharedInstance().defaultTextColor,
      0.8
    );
    // >>> DeepL langauge button >>>
    self.webview.lanButton = UIButton.buttonWithType(0);
    // <<< DeepL langauge button <<<
    self.webview.hidden = true;
    self.webview.lastOffset = 0;
    // self.updateButton();
    self.view.addSubview(self.webview);
    // <<< DeepL view <<<

    // >>> opacity button >>>
    self.opacityButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.opacityButton,"changeOpacity:")
    self.opacityButton.setTitleForState('100%', 0);
    self.opacityButton.titleLabel.font = UIFont.systemFontOfSize(12);
    // <<< opacity button <<<
    // >>> close button >>>
    self.closeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.closeButton,"closeButtonTapped:")
    self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< close button <<<
    // >>> max button >>>
    self.maxButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.maxButton,"maxButtonTapped:")
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< max button <<<
    // >>> screen button >>>
    self.screenButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.screenButton,"changeScreen:")
    self.screenButton.setImageForState(self.screenImage,0)
    // <<< screen button <<<
    // >>> engine button >>>
    self.engineButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.engineButton,"changeEngine:")
    self.engineButton.setTitleForState('Bing', 0);
    self.engineButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);
    // <<< engine button <<<
    // >>> home button >>>
    self.homeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.homeButton,"homeButtonTapped:")
    self.homeButton.setImageForState(self.homeImage,0)
    // <<< home button <<<
    // >>> search button >>>
    self.searchButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.searchButton,"searchButtonTapped:")
    self.searchButton.setTitleForState('🔍', 0);
    // <<< search button <<<
    // >>> move button >>>
    self.moveButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.moveButton)
    // <<< move button <<<
    // >>> goForward button >>>
    self.goForwardButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.goForwardButton,"goForwardButtonTapped:")
    self.goForwardButton.setImageForState(self.goforwardImage,0)
    // <<< goForward button <<<
      // >>> goBack button >>>
    self.goBackButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.goBackButton,"goBackButtonTapped:")
    self.goBackButton.setImageForState(self.gobackImage,0)
    // <<< goBack button <<<
    // >>> refresh button >>>
    self.refreshButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.refreshButton,"refreshButtonTapped:")
    self.refreshButton.setImageForState(self.reloadImage,0)
    // <<< refresh button <<<

    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
  },
  viewWillAppear: function(animated) {
    self.webview.delegate = self;
  },
  viewWillDisappear: function(animated) {
    self.webview.stopLoading();
    self.webview.delegate = null;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
  viewWillLayoutSubviews: function() {
    if (self.miniMode) {
      return
    }

    var viewFrame = self.view.bounds;
    self.closeButton.frame = {
      x: viewFrame.x + viewFrame.width-18,
      y: viewFrame.y,
      width: 18,
      height: 18,
    };
    self.maxButton.frame = {
      x: viewFrame.x + viewFrame.width-43,
      y: viewFrame.y,
      width: 18,
      height: 18,
    };
    if (self.toolbarOn) {
      self.screenButton.frame = {
        x: viewFrame.x + viewFrame.width - 40,
        y: viewFrame.y + viewFrame.height - 25,
        width: 40,
        height: 25,
      };
    }else{
      self.screenButton.frame = {
        x: viewFrame.x + viewFrame.width - 40,
        y: viewFrame.y + viewFrame.height - 30,
        width: 33,
        height: 25,
      };
    }
    self.engineButton.frame = {
      x: viewFrame.x + viewFrame.width - 105,
      y: viewFrame.y + viewFrame.height - 25,
      width: 60,
      height: 25,
    };


    if (viewFrame.width <= 300) {
      self.moveButton.frame = {
        x: viewFrame.x + viewFrame.width*0.5-75,
        y: viewFrame.y,
        width: viewFrame.width*0.5,
        height: 12,
      };
        self.refreshButton.hidden = true
        self.goBackButton.hidden = true
        self.goForwardButton.hidden = true
        self.engineButton.hidden = true
      self.homeButton.frame = {
        x: viewFrame.x + (viewFrame.width-200)*0.8+43,
        y: viewFrame.y + viewFrame.height - 25,
        width: 49,
        height: 25,
      };    
      if (self.toolbarOn) {
        self.searchButton.frame = {
          x: viewFrame.x + (viewFrame.width-200)*0.8+100,
          y: viewFrame.y + viewFrame.height - 25,
          width: 49,
          height: 25,
        };
      }else{
        self.searchButton.frame = {
          x: viewFrame.x + viewFrame.width - 75,
          y: viewFrame.y + viewFrame.height - 25,
          width: 30,
          height: 25,
        };
      }
      self.opacityButton.frame = {
        x: viewFrame.x + (viewFrame.width-200)*0.8,
        y: viewFrame.y + viewFrame.height - 25,
        width: 40,
        height: 25,
      };
    }else{
      self.moveButton.frame = {
        x: viewFrame.x + viewFrame.width*0.5-75,
        y: viewFrame.y,
        width: 150,
        height: 12,
      };
      if (self.toolbarOn) {
        self.refreshButton.hidden = false
        self.goBackButton.hidden = false
        self.goForwardButton.hidden = false
        self.engineButton.hidden = false
      }
      self.homeButton.frame = {
        x: viewFrame.x + viewFrame.width*0.5-35,
        y: viewFrame.y + viewFrame.height - 25,
        width: 49,
        height: 25,
      };    
      if (self.toolbarOn) {
        self.searchButton.frame = {
          x: viewFrame.x + viewFrame.width*0.5+19,
          y: viewFrame.y + viewFrame.height - 25,
          width: 49,
          height: 25,
        };
      }else{
        self.searchButton.frame = {
          x: viewFrame.x + viewFrame.width - 75,
          y: viewFrame.y + viewFrame.height - 30,
          width: 30,
          height: 25,
        };
      }
      self.opacityButton.frame = {
        x: viewFrame.x + viewFrame.width*0.5-80,
        y: viewFrame.y + viewFrame.height - 25,
        width: 40,
        height: 25,
      };
    }
    self.goBackButton.frame = {
      x: viewFrame.x,
      y: viewFrame.y + viewFrame.height - 25,
      width: 30,
      height: 25,
    };
    self.goForwardButton.frame = {
      x: viewFrame.x+36,
      y: viewFrame.y + viewFrame.height - 25,
      width: 30,
      height: 25,
    };
    self.refreshButton.frame = {
      x: viewFrame.x + 72,
      y: viewFrame.y + viewFrame.height - 25,
      width: 30,
      height: 25,
    };
    if (self.toolbarOn) {
      self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+6,width:viewFrame.width-2,height:viewFrame.height-36}
    }else{
      self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+6,width:viewFrame.width-2,height:viewFrame.height-6}
    }
    var webviewFrame = self.webview.bounds;
  },
  scrollViewDidScroll: function() {
  },
  webViewDidStartLoad: function(webView) {
    // self.changeUA()
    // let requestFromHomepage = self.webview.url === "https://m.inftab.com/"
    let currentURL = webView.request.URL().absoluteString();
    // var pasteBoard = UIPasteboard.generalPasteboard()
    // pasteBoard.string = currentURL
    // Application.sharedInstance().showHUD(currentURL, self.view.window, 5);
    if (/^https:\/\/d.bilibili/.test(currentURL)) {
      webView.stopLoading();
    }
      // Application.sharedInstance().showHUD("123", self.view.window, 5);
    if (/^bilibili:/.test(currentURL)) {
      // Application.sharedInstance().showHUD("123", self.view.window, 5);
      // webView.stopLoading();
      // webview.scrollView.contentOffset = {x: 0, y: 100}; 
      webView.evaluateJavaScript(
      `//document.getElementsByClassName("launch-app-btn m-float-openapp")[0].style.display = "none";    
      document.getElementsByClassName("launch-app-btn m-nav-openapp")[0].style.display = "none"; 
      document.getElementsByClassName("mplayer-fullscreen-call-app")[0].style.display = "none";
      let itemToRemove = document.getElementsByClassName("mplayer-widescreen-callapp")[0]
      itemToRemove.parentNode.removeChild(itemToRemove)
      itemToRemove = document.getElementsByClassName("m-video2-awaken-btn")[0]
      itemToRemove.parentNode.removeChild(itemToRemove)
      itemToRemove = document.getElementsByClassName("launch-app-btn icon-spread")[0]
      itemToRemove.parentNode.removeChild(itemToRemove)
      // document.getElementsByClassName("m-video-player")[0].style = "position: absolute; width: 100%; height: 100%; left: 0; top: 0;";`,
      (ret) => {
      }

    );         
  //   webView.evaluateJavaScript(
  //   `window.location.href`,
  //   (ret) => {
  //   // Application.sharedInstance().showHUD(ret, self.view.window, 5);
      
  //   }
  // );
      // return
    }
    if (/^marginnote3app/.test(currentURL)) {
      Application.sharedInstance().openURL(NSURL.URLWithString(currentURL));
      webView.stopLoading();
      return
    }

    // var pasteBoard = UIPasteboard.generalPasteboard()
    // pasteBoard.string = currentURL
    UIApplication.sharedApplication().networkActivityIndicatorVisible = true;
    // self.screenButton.setTitleForState('Loading', 0);

    if (self.engine === "Craft" || self.engine === "Notion") {
      return;
    }
    self.refreshButton.setImageForState(self.stopImage,0)
    // self.refreshButton.setTitleForState('✖️', 0);
    self.changeButtonOpacity(0.5)
    self.isLoading = true;

    // if (self.engine === "📝 Deepl") {
    //   self.updateDeeplOffset()
    // }
    // if (self.engine === "📝 Baidu") {
    //   self.updateBaiduOffset()
    // }
    // if (self.engine === "🔍 ResearchGate") {
    //   self.updateRGOffset()
    // }
  },
  webViewDidFinishLoad: function(webView) {
    // self.changeUA()
    // if (self.ishacked) {
    //   self.ishacked = false
    // }
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    // self.getCurrentURL(webView)
    // let currentURL = webView.request.URL().absoluteString();
    self.webview.url = webView.request.URL().absoluteString();
    // Application.sharedInstance().showHUD(self.webview.url, self.view.window, 5);
    // self.screenButton.setTitleForState('Screen', 0);
    if (self.engine === "Craft" || self.engine === "Notion") {
      return;
    }
    self.refreshButton.setImageForState(self.reloadImage,0)

    // self.refreshButton.setTitleForState('🔄', 0);
    self.changeButtonOpacity(1.0)
    self.isLoading = false;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    if (self.webview.url === "https://m.bilibili.com/") {
      self.updateBilibiliOffset()
      return;
    }
    // if (/bilibili.com\/video\/\w+/.test(self.webview.url)) {
    //   self.webview.evaluateJavaScript(
    //     `let itemToRemove = document.getElementsByClassName("openapp-dialog large")[0]
    //   itemToRemove.parentNode.removeChild(itemToRemove)
    //     `,
    //     (ret) => {}
      
    //   )
    // }
    // if ()
    switch (self.engine) {
      case "Deepl":
        self.updateDeeplOffset()
        break;
      case "BaiduTranslate":
        self.updateBaiduOffset()
        break;
      case "ResearchGate":
        self.updateRGOffset()
        break;
      case "Bing":
        self.updateBingOffset()
        break;
      default:
        break;
    }//m-home-float-openapp
    // }
    // self.currentURL = webView.request.URL.absoluteString;
    //  Application.sharedInstance().showHUD(self.webview.url, self.view.window, 2);

  },
  webViewDidFailLoadWithError: function(webView, error) {
    // self.screenButton.setTitleForState('Screen', 0);
    self.refreshButton.setImageForState(self.reloadImage,0)
    // self.refreshButton.setTitleForState('🔄', 0);
    self.changeButtonOpacity(1.0)
    self.isLoading = false;
    self.getCurrentURL()
    //UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    //var lan = NSLocale.preferredLanguages() ? NSLocale.preferredLanguages()[0].substring(0,2) : 'en';
    //if (lan == 'zh') {
    //  Application.sharedInstance().showHUD('错误', self.view.window, 2);
    //} else {
    //  Application.sharedInstance().showHUD('Failed to load DeepL translator, please try again later', self.view.window, 2);
    //}
  },
  // webViewShouldStartLoadWithRequestNavigationType: function (test=0,test0=0,test1=0,test2=0) {
  //    Application.sharedInstance().showHUD('错误', self.view.window, 2);
  //   return true
  // },
  changeScreen: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'🌗 Left',object:self,selector:'leftButtonTapped:',param:'left',checked:self.customMode==="left"},
      {title:'🌘 Left 1/3',object:self,selector:'left13ButtonTapped:',param:'left',checked:self.customMode==="left13"},
      {title:'🌓 Right',object:self,selector:'rightButtonTapped:',param:'right',checked:self.customMode==="right"},
      {title:'🌒 Right 1/3',object:self,selector:'right13ButtonTapped:',param:'right',checked:self.customMode==="right13"},
      {title:'🌟 Dynamic',object:self,selector:'dynamicButtonTapped:',param:'right',checked:self.dynamic},
      {title:'🌟 Toolbar',object:self,selector:'toggleToolbar:',param:'right',checked:self.toolbarOn},

    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 200,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeEngine: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    var entriesNames = Object.keys(self.entries)
    // Application.sharedInstance().showHUD(entriesNames,self.view.window,2)
    var commandTable = entriesNames.map(entriesName => {
      return {title:self.entries[entriesName].title,object:self,selector:'searchWithEngine:',param:entriesName,checked:self.engine===entriesName}
    }).concat(
      {title:'🌐 Open in new window',object:self,selector:'openInNewWindow:',param:self.webview.url},
      {title:'🌐 Open new window',object:self,selector:'openNewWindow:',param:self.homePageURL},
      {title:'🌐 Open in browser',object:self,selector:'openInBrowser:',param:'right'},
      {title:'🌐 Copy link',object:self,selector:'copyCurrentURL:',param:'right'},
      {title:'🌐 Open copied link',object:self,selector:'openCopiedURL:',param:'right'}
    )
    menuController.commandTable = commandTable
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 200,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 100,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
    self.opacityButton.setTitleForState(`${opacity*100}%`, 0);
  },
  toggleToolbar:function (opacity) {
    self.view.popoverController.dismissPopoverAnimated(true);
    // Application.sharedInstance().showHUD(self.toolbarOn,self.view.window,2)
    self.toolbarOn = !self.toolbarOn
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.toolbarOn, 'MNBrowser_toolbar');
    self.opacityButton.hidden = !self.toolbarOn
    // self.searchButton.hidden = !self.toolbarOn
    self.homeButton.hidden = !self.toolbarOn
    self.goBackButton.hidden = !self.toolbarOn
    self.goForwardButton.hidden = !self.toolbarOn
    self.refreshButton.hidden = !self.toolbarOn
    // self.screenButton.hidden = !self.toolbarOn
    self.engineButton.hidden = !self.toolbarOn
    var viewFrame = self.view.bounds;
    if (self.toolbarOn) {
      self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height-40}
    }else{
      self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height}
    }
  },

  searchWithEngine: function (engine) {
    self.engine = engine
    NSUserDefaults.standardUserDefaults().setObjectForKey(engine, 'MNBrowser_engine');
    self.search(self.selectedText)
    self.view.popoverController.dismissPopoverAnimated(true);
  },
  openInNewWindow: function (url) {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('newWindow', self.view.window, {url:url,test:"12"})
    self.homePage();
  },
  openNewWindow: function () {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('newWindow', self.view.window, {url:self.homePageURL,test:"12"})
  },
  openInBrowser: function (engine) {
    Application.sharedInstance().openURL(NSURL.URLWithString(self.webview.url));
  },
  copyCurrentURL: function (engine) {
    var pasteBoard = UIPasteboard.generalPasteboard()
    pasteBoard.string = self.webview.url
    // Application.sharedInstance().showHUD(self.webview.url,self.view.window,2)

    // Application.sharedInstance().openURL(NSURL.URLWithString(self.webview.url));
  },
  openCopiedURL: function (engine) {
    var pasteBoard = UIPasteboard.generalPasteboard()
    self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(pasteBoard.string)));
    // Application.sharedInstance().openURL(NSURL.URLWithString(self.webview.url));
  },
  homeButtonTapped: function() {
      // Application.sharedInstance().showHUD(self.isMainWindow,self.view.window,2)

    if (self.minimized) {
      self.minimized = false
      self.view.frame = self.lastFrame
      // Application.sharedInstance().showHUD(self.currentView,self.view.window,2)
      self.webview.hidden = false
    }
    self.homePage()
  },
  searchButtonTapped: function() {
    // self.switchView();
    if (self.minimized) {
      self.view.frame = self.lastFrame
      // Application.sharedInstance().showHUD(self.currentView,self.view.window,2)
      self.minimized = false
      self.webview.hidden = false
    }
    // self.webview.goBack();
    self.search(self.selectedText)
    // Application.sharedInstance().showHUD(Object.keys(self),self.view.window,2)

    // self.view.frame = {x:100,y:100,width:100,height:100}
    // self.close();
  },
  goBackButtonTapped: function() {
    // self.switchView();
    if (self.minimized) {
      self.view.frame = self.lastFrame
      // Application.sharedInstance().showHUD(self.currentView,self.view.window,2)
      self.minimized = false
      self.webview.hidden = false
    }
    self.webview.goBack();
    // self.search('')
    // Application.sharedInstance().showHUD(Object.keys(self),self.view.window,2)

    // self.view.frame = {x:100,y:100,width:100,height:100}
    // self.close();
  },
  goForwardButtonTapped: function() {
    // self.switchView();
    if (self.minimized) {
      self.view.frame = self.lastFrame
      // Application.sharedInstance().showHUD(self.currentView,self.view.window,2)
      self.minimized = false
      self.webview.hidden = false
    }
    self.webview.goForward();
    // self.search('')
    // Application.sharedInstance().showHUD(Object.keys(self),self.view.window,2)

    // self.view.frame = {x:100,y:100,width:100,height:100}
    // self.close();
  },
  refreshButtonTapped: function(para) {

    if (self.isLoading) {
      self.webview.stopLoading();
      // self.screenButton.setTitleForState('Screen', 0);
      // self.refreshButton.setTitleForState('🔄', 0);
      self.refreshButton.setImageForState(self.reloadImage,0)
      self.changeButtonOpacity(1.0)
      self.isLoading = false;
    }else{
      self.webview.reload();
    }
    // self.search('')
    // Application.sharedInstance().showHUD(Object.keys(self),self.view.window,2)

    // self.view.frame = {x:100,y:100,width:100,height:100}
    // self.close();
  },
  dynamicButtonTapped: function() {
    self.view.popoverController.dismissPopoverAnimated(true);
    // self.switchView();
    self.dynamic = true;
    self.custom = false;
    self.customMode = "None"
    if (self.minimized) {
      self.view.frame = self.lastFrame
      // Application.sharedInstance().showHUD(self.currentView,self.view.window,2)
      self.minimized = false
      self.webview.hidden = false
      self.moveButton.hidden = false
      self.maxButton.hidden = false
      self.closeButton.hidden = false
    }
    // self.view.frame = {x:100,y:100,width:100,height:100}
    // self.close();
  },
  closeButtonTapped: function() {
    // self.switchView();
    self.view.hidden = true;
    // self.custom = false;
    // self.minimized = false;
    // self.dynamic = true;

    var url = 'https://m.inftab.com/'
    // var url = 'https://www.bilibili.com/online.html'
    self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url)));
  // Application.sharedInstance().showHUD(self.isMainWindow,self.view.window,2)

    if (self.isMainWindow) {
      NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('close', self.view.window, {test:123})
      
    }
  },
  minButtonTapped: function() {
  // Application.sharedInstance().showHUD('textSelected',self.view.window,2)
  // try {
    // NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('trst', self.view.window, {test:123})
  // } catch (error) {
  //   Application.sharedInstance().showHUD(error,self.view.window,2)
    
  // }
    const frame = Application.sharedInstance().studyController(this.window).view.bounds
    self.lastFrame = self.view.frame
    self.view.frame = {x:0,y:frame.height-60,width:100,height:45}
    self.moveButton.hidden = true
    self.minButton.hidden = true
    self.maxButton.hidden = true
    self.closeButton.hidden = true
    // Application.sharedInstance().showHUD('minimize',self.view.window,2)
    self.minimized = true
    self.dynamic = false;
    self.webview.hidden = true



    // Application.sharedInstance().showHUD("watch mode: "+self.watchMode,self.window,2)
    // self.watchButton.setTitleForState('1', 0);
  },
  leftButtonTapped: function() {
    self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:50,width:splitLine-40,height:height-50}
    self.custom = true;
    self.customMode = "left"
    self.minimized = false
    self.dynamic = false;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  left13ButtonTapped: function() {
    self.customMode = "left13"
    self.minimized = false
    self.dynamic = false;
    self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:60,width:studyFrame.width/3.+40,height:height-60}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  rightButtonTapped: function() {
    self.customMode = "right"
    self.minimized = false
    self.dynamic = false;
    self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  right13ButtonTapped: function() {
    self.custom = true;
    self.customMode = "right13"
    self.minimized = false
    self.dynamic = false;
    self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  maxButtonTapped: function() {
    if (self.maximized) {
      self.customMode = "none"
      self.custom = false;
      self.view.frame = self.lastFrame
      self.maximized = false
      return
    }
    const frame = Application.sharedInstance().studyController(this.window).view.bounds
    self.lastFrame = self.view.frame
    self.view.frame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
    self.customMode = "full"
    self.custom = true;
    self.minimized = false
    self.maximized = true
    self.dynamic = false;
    self.webview.hidden = false
  },
  onMoveGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let translationX = locationInView.x - baseframe.width*0.5
    let translationY = locationInView.y - baseframe.height*0.5
    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = Application.sharedInstance().studyController(self.view.window).view.bounds
    let y = frame.y+translationY
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = frame.x+translationX
    if (!self.miniMode) {
      if (x+frame.width*0.5-40<0) {
        self.miniMode = true 
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.view.frame = {
          x:0,
          y:frame.y,
          width:40,
          height:40
        }
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.engineButton.hidden = true
        self.moveButton.frame = {
          x: -10,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
      if (x>studyFrame.width-frame.width*0.5-40) {
        x=studyFrame.width-frame.width*0.5-40
        self.miniMode = true     
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.view.frame = {
          x:studyFrame.width-40,
          y:frame.y,
          width:40,
          height:40
        }
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.engineButton.hidden = true
        self.goBackButton.hidden = true
        self.goForwardButton.hidden = true
        self.refreshButton.hidden = true
        self.opacityButton.hidden = true
        self.searchButton.hidden = true
        self.homeButton.hidden = true
        self.moveButton.frame = {
          x: 0,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
    }else{
      if (x+frame.width*0.5-50<=0) {
        x = -frame.width*0.5+20
      }else if (x>studyFrame.width-frame.width*0.5-50) {
        x = studyFrame.width-40
      }else{
        self.view.frame = {
          x:40,
          y:y,
          width:self.lastFrame.width,
          height:self.lastFrame.height
        }
        viewFrame = self.view.bounds;
        self.miniMode = false
        self.moveButton.frame = {
          x: viewFrame.x + viewFrame.width*0.5-75,
          y: viewFrame.y + 5,
          width: 150,
          height: 10,
        };
        self.webview.hidden = false
        self.closeButton.hidden = false
        self.maxButton.hidden = false
        self.screenButton.hidden = false
        self.searchButton.hidden = false
        if (self.toolbarOn) {
          self.homeButton.hidden = false
          self.engineButton.hidden = false
          self.opacityButton.hidden = false
        }

        return
      }
    }

    // if (x>studyFrame.width-frame.width*0.5+50) {
    //   x=studyFrame.width-frame.width*0.5+50
    // }

    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
     self.view.frame = {x:x,y:y,width:frame.width,height:frame.height}
    // if (gesture.state === "begin") {
      
    // }
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let frame = self.view.frame
    let width = locationInView.x+baseframe.x+baseframe.width*0.5
    let height = locationInView.y+baseframe.y+baseframe.height*0.5
    if (width <= 200) {
      width = 200
    }
    if (height <= 100) {
      height = 100
    }
    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
     self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}

    // if (gesture.state === "begin") {
      
    // }
  }
});

browserController.prototype.homePage = function() {
  // var url = 'https://m.inftab.com/'
  // var url = 'https://useragent.buyaocha.com/'
  // try {
  // this.webView.loadFileURLAllowingReadAccessToURL(
  //     NSURL.fileURLWithPath(self.mainPath + '/test.html'),
  //     NSURL.fileURLWithPath(self.mainPath+"/")
  // )
  // } catch (error) {
  // Application.sharedInstance().showHUD(error, this.view.window, 2);
    
  // }

  this.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(self.homePageURL)));
  // this.webview.hidden = true
  // this.mdxDictView.hidden = false
  this.currentView = "deepl"
  // var url = `${this.webview.url}#en/${this.webview.lanCode}/${encodeURIComponent(text.replaceAll('/', '\\/'))}`;
  // this.changeUA();
};

browserController.prototype.search = function(text) {
  // NSUserDefaults.standardUserDefaults().synchronize();
  // let object = NSUserDefaults.standardUserDefaults().objectForKey("UserAgent");
    //  Application.sharedInstance().showHUD(text, this.view.window, 2);
  var url;
  url = this.entries[this.engine].link.replace('%s',encodeURIComponent(text.replaceAll('/', '\\/')))
  // Application.sharedInstance().showHUD(url, this.view.window, 2);
  this.searchButton.setTitleForState(this.entries[this.engine].symbol, 0);
  this.engineButton.setTitleForState(this.entries[this.engine].engine, 0);
  const headers = {
    "User-Agent":
      "Mozilla/5.0 (Linux; Android 4.2.1; M040 Build/JOP40D) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.59 Mobile Safari/537.36",
    "Content-Type": "application/x-www-form-urlencoded"  }
    // request.setAllHTTPHeaderFields(headers)
    // request.setHTTPMethod("GET")
    // request.setURL(NSURL.URLWithString(url))
    // try {
    // request.setValueForHTTPHeaderField("User-Agent",'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15')
    // request.setValueForHTTPHeaderField('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"User-Agent")
    // // request.setValueForHTTPHeaderField('2',"Refresh")
      
    // } catch (error) {
    //  Application.sharedInstance().showHUD(error, self.view.window, 2);
      
    // }
    //  Application.sharedInstance().showHUD(this.engine === "Bilibili" && this.webview.url === url, self.view.window, 2);
  if (this.engine === "Bilibili" && (this.webview.url === url || /bilibili.com\/video\/\w+/.test(this.webview.url))) {
    //  Application.sharedInstance().showHUD("bilibili", this.view.window, 2);
    self.webview.evaluateJavaScript(
    `window.location.href`,
    (ret) => {
    let bid = ret.match(/(?<=video\/)\w+/)[0]
    // Application.sharedInstance().showHUD(bid, self.view.window, 5);
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('newVideoWindow', self.view.window, {bid:bid,url:ret})
    self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString("https://m.bilibili.com")));
    //   self.webview.evaluateJavaScript(
    //     `
    //   try {
    //     document.getElementsByClassName("m-video-player")[0].style.display = "none"; 
    //     document.getElementsByClassName("m-navbar")[0].style.display = "none";
    //     let itemToRemove = document.getElementsByClassName("openapp-dialog large")[0]
    //   itemToRemove.parentNode.removeChild(itemToRemove)
    //     itemToRemove = document.getElementsByClassName("fixed-module")[0]
    //   itemToRemove.parentNode.removeChild(itemToRemove)
    //   } catch (error) {
        
    //   }
    //     var body = document.getElementsByTagName("body");
    // var div = document.createElement("div");
    // div.innerHTML = '<iframe class="embedPlayer" style="position: absolute; width: 100%; height: 100%; left: 0; top: 0;" src="//player.bilibili.com/player.html?bvid=${bid}&high_quality=1" scrolling="no" border="0" frameborder="no" framespacing="0"></iframe> ';
    // document.body.appendChild(div);`,
    //     (ret) => {
    //     ;

    //   })
    })
    return
  }
  if (this.webview.url !== url) {
    this.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url))); 
  }
  // this.webview.loadRequest(request);
    //  Application.sharedInstance().showHUD(request.valueForHTTPHeaderField("User-Agent"), self.view.window, 2);
  this.webview.hidden = false
  // this.changeUA();
  // var url = `${this.webview.url}#en/${this.webview.lanCode}/${encodeURIComponent(text.replaceAll('/', '\\/'))}`;
  
};

browserController.prototype.switchView = function() {
    this.webview.hidden = !this.mdxDictView.hidden;
};
browserController.prototype.embedVideo = function(bid) {
    this.webview.evaluateJavaScript(
        `var body = document.getElementsByTagName("body");
    var div = document.createElement("div");
    div.innerHTML = '<iframe class="embedPlayer" style="position: absolute; width: 100%; height: 100%; left: 0; top: 0;" src="//player.bilibili.com/player.html?bvid=${bid}&high_quality=1" scrolling="no" border="0" frameborder="no" framespacing="0"></iframe> ';
    document.body.appendChild(div);`,
        (ret) => {
        ;

      })
};

browserController.prototype.updateButton = function() {
  if(this.webview.lanCode == 'en')
    this.webview.lanButton.setTitleForState('English',0);
  else if(this.webview.lanCode == 'zh')
    this.webview.lanButton.setTitleForState('Chinese',0);
  else if(this.webview.lanCode == 'ja')
    this.webview.lanButton.setTitleForState('Japanese',0);
  else if(this.webview.lanCode == 'de')
    this.webview.lanButton.setTitleForState('German',0);
  else if(this.webview.lanCode == 'fr')
    this.webview.lanButton.setTitleForState('French',0);
  else if(this.webview.lanCode == 'es')
    this.webview.lanButton.setTitleForState('Spanish',0);
  else if(this.webview.lanCode == 'ru')
    this.webview.lanButton.setTitleForState('Russian',0);
  else if(this.webview.lanCode == 'it')
    this.webview.lanButton.setTitleForState('Italian',0);
};

browserController.prototype.updateDeeplOffset = function() {
  if(!this.webview || !this.webview.window)return;
  if (Application.sharedInstance().osType !== 1) {
    this.webview.evaluateJavaScript(
      `document.getElementsByClassName("dl_header")[0].style.display="none";
       document.getElementsByClassName("lmt__docTrans-tab-container")[0].style.display="none";
       document.getElementsByClassName("lmt__sides_container")[0].style.margin = 0;
       document.querySelector("#dl_translator").style.cssText = "padding-top: 20px";
       document.getElementsByClassName("lmt__language_container")[0].style.display = "none";
       document.getElementsByClassName("lmt__language_container")[1].style.display = "none";
       document.getElementsByClassName("lmt__target_toolbar")[0].style.display = "none";
       document.querySelector("#dl_cookieBanner").style.display="none";
       document.querySelector("#lmt_quotes_article").style.display="none";
       document.querySelector("#lmt__dict").style.margin = 0;
       document.querySelector("#lmt_pro_ad_container").style.display = "none";
       document.querySelector("body > div.dl_footerV2_container").style.display = "none";`,
      (ret) => {}
    );
  } else {
    this.webview.evaluateJavaScript(
      `document.querySelector("#gatsby-focus-wrapper > header").style.display = "none";
       document.querySelector("#gatsby-focus-wrapper > footer").style.display = "none";
       document.getElementsByClassName("TranslatorPage-module--otherSections--3cbQ7")[0].style.display = "none";`,
      (ret) => {}
    );
  }
  this.webview.evaluateJavaScript(
    'document.getElementsByClassName("lmt__side_container--target")[0].getBoundingClientRect().top + document.body.scrollTop+document.documentElement.scrollTop;',
    function (ret) {
      if (!this.webview) return;
      if (ret && !isNaN(parseFloat(ret))) {
        this.webview.scrollView.contentOffset = {x: 0, y: parseFloat(ret) + 0};          
      } else {
        this.webview.scrollView.contentOffset = {x: 0, y: 130};          
      }
    }
  );
};

browserController.prototype.updateBaiduOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.webview.evaluateJavaScript(
    `document.getElementsByClassName("new-header")[0].style.display = "none";`,
    (ret) => {}
  );
};

browserController.prototype.updateBingOffset = function() {
  if(!this.webview || !this.webview.window)return;
    this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(0.5, true, () => {
        this.webview.evaluateJavaScript(
          `document.getElementsByClassName("bottom bnp_rich_div_visible")[0].style.display = "none"
          var customUserAgent = 'Mozilla/5.0 (Linux; U; Android 7.0; zh-CN; PRO 7-S Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.2.46 Mobile Safari/537.36 AliApp(DingTalk/4.6.29) com.alibaba.android.rimet/11388461 Channel/10002068 language/zh-CN';
 
//修改后的userAgent            
            Object.defineProperty(navigator, 'userAgent', {
              value: customUserAgent,
              writable: false
            });
 
//打印
 
console.log(navigator.userAgent);`,
          (ret) => {}
        );
        this.viewTimer.invalidate();
    });

};

browserController.prototype.updateRGOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.webview.evaluateJavaScript(
    `document.getElementsByClassName("header")[0].style.display = "none"`,
    (ret) => {}
  );
};

browserController.prototype.updateBilibiliOffset = function() {
  if(!this.webview || !this.webview.window)return;
  // this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(0.1, true, () => {

    this.webview.evaluateJavaScript(
      `document.getElementsByClassName("m-home-float-openapp")[0].style.display = "none"; 
      document.getElementsByClassName("launch-app-btn m-nav-openapp")[0].style.display = "none"; 
      // document.getElementsByClassName("m-navbar")[0].style.display = "none";    
      // document.getElementsByClassName("channel-menu")[0].style.display = "none";    `,
      (ret) => {
      }
    );
    // this.webview.scrollView.contentOffset = {x: 10, y: 100};          
    // this.viewTimer.invalidate();

  // });
};

browserController.prototype.getCurrentURL = function(webview) {
  if(!this.webview || !this.webview.window)return;
  this.webview.evaluateJavaScript(
    `window.location.href`,
    (ret) => {
      this.webview.url = ret
    }
  );
};

browserController.prototype.changeUA = function() {

  if(!this.webview || !this.webview.window)return;
  this.webview.evaluateJavaScript(
        `var customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36';
            Object.defineProperty(navigator, 'userAgent', {
              value: customUserAgent,
              writable: false
            });
        `,
       
      (ret) => {}
  )
}
browserController.prototype.changeButtonOpacity = function(opacity) {
    this.opacityButton.layer.opacity = opacity
    this.searchButton.layer.opacity = opacity
    this.homeButton.layer.opacity = opacity
    this.goBackButton.layer.opacity = opacity
    this.goForwardButton.layer.opacity = opacity
    this.refreshButton.layer.opacity = opacity
    this.screenButton.layer.opacity = opacity
    this.engineButton.layer.opacity = opacity
    this.moveButton.layer.opacity = opacity
    this.maxButton.layer.opacity = opacity
    this.closeButton.layer.opacity = opacity
}
browserController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 8;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}
function getSplitLine() {
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let readerFrame = Application.sharedInstance().studyController(this.window).readerController.view.frame
    let hidden = Application.sharedInstance().studyController(this.window).readerController.view.hidden//true代表脑图全屏
    let rightMode = Application.sharedInstance().studyController(this.window).rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      let splitLine = studyFrame.width*0.5
      return splitLine
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }